
enemy = {}

function enemy_load()
	enemy.width = 10
	enemy.height = 10
	enemy_timer = 0
	enemy_timerLim = 1
	enemy_difficult = 0
	enemy_difficultLim = 10
end

function enemy_generate(dt)
	enemy_timer = enemy_timer + dt
	enemy_difficult = enemy_difficult + dt
	if enemy_timer >= enemy_timerLim then
		enemy_spawn(math.random(0.5,17.5)*20,-30)
		enemy_timer = 0
	end
	if enemy_difficult >= enemy_difficultLim and
	enemy_timerLim > 0.15 then
		enemy_timerLim = enemy_timerLim - 0.1
		enemy_difficult = 0
	end
end

function enemy_spawn(x,y)
	table.insert(enemy, {dis = 0, speed = math.random(200,300),x = x,y = y, v1x = x,v1y = y,  v2x = x,v2y = y+enemy.height,  v3x = x+enemy.height,v3y = y+enemy.height,  v4x = x+enemy.height,v4y = y, c1x = x,c1y = y, c2x = x,c2y = y, c3x = x,c3y = y, c4x = x,c4y = y, e1x = x,e1y = y, e2x = x,e2y = 0, ax = 0,ay = 0, bx = 0,by = 0})
end	

function enemy_remove()
	for k in pairs (enemy) do
    enemy[k] = nil
	end
end

function enemy_move(dt)
	for i,v in ipairs(enemy) do
		v.y = v.y + v.speed * dt
		v.v1y = v.v1y + v.speed * dt
		v.v2y = v.v2y + v.speed * dt
		v.v3y = v.v3y + v.speed * dt
		v.v4y = v.v4y + v.speed * dt
	end
end

function enemy_distance()
	for i,v in ipairs(enemy)do
		v.dis = math.sqrt((lightx - v.x+5)^2 + (lighty - v.y+5)^2)
	end
end

function enemy_sort()
	table.sort(enemy, function (a,b)
      return (a.dis > b.dis)
    end)
end

function UPDATE_ENEMY(dt)
	enemy_generate(dt)
	enemy_move(dt)
	enemy_distance()
	enemy_sort()
end
