

function pointfind()
	lightx = player.x + 10
	lighty = player.y + 10
	for i,v in ipairs(enemy) do
		local xdiff1 = lightx - v.c1x
		local ydiff1 = lighty - v.c1y
		local xdiff2 = lightx - v.c2x
		local ydiff2 = lighty - v.c2y
		v.e1x = v.x
		v.e1y = v.y
		v.e2x = v.x
		v.e2y = v.y
		
		while v.e1x > 0 and
		v.e1x < 400 and
		v.e1y > 0 and
		v.e1y < 600 do
			v.e1x = v.e1x - xdiff1
			v.e1y = v.e1y - ydiff1
		end
		
		while v.e2x > 0 and
		v.e2x < 400 and
		v.e2y > 0 and
		v.e2y < 600 do
			v.e2x = v.e2x - xdiff2
			v.e2y = v.e2y - ydiff2
		end
	end
end


function pointtest()
	for i,v in ipairs(enemy) do	
		if lightx <= v.x then
			if lighty <= v.y then
				v.c1x = v.v4x
				v.c1y = v.v4y
				v.c2x = v.v2x
				v.c2y = v.v2y
				
				v.ax = v.e1x + 400
				v.ay = v.e1y
				v.bx = v.e2x + 400
				v.by = v.e2y
			elseif lighty >= v.y and
			lighty <= v.v3y then
				v.c1x = v.v1x
				v.c1y = v.v1y
				v.c2x = v.v2x
				v.c2y = v.v2y

				v.ax = v.e1x + 400
				v.ay = v.e1y
				v.bx = v.e1x + 400
				v.by = v.e1y
			elseif lighty >= v.v3y then
				v.c1x = v.v1x
				v.c1y = v.v1y
				v.c2x = v.v3x
				v.c2y = v.v3y

				v.ax = v.e1x + 400
				v.ay = v.e1y
				v.bx = v.e2x + 400
				v.by = v.e2y
			end
		elseif lightx >= v.x and
		lightx <= v.v3x then
			if lighty <= v.y then
				v.c1x = v.v4x
				v.c1y = v.v4y
				v.c2x = v.v1x
				v.c2y = v.v1y

				v.ax = v.e1x
				v.ay = v.e1y + 600
				v.bx = v.e2x
				v.by = v.e2y + 600
			elseif lighty >= v.y and
			lighty <= v.v3y then
				
			elseif lighty >= v.v3y then
				v.c1x = v.v2x
				v.c1y = v.v2y
				v.c2x = v.v3x
				v.c2y = v.v3y

				v.ax = v.e1x
				v.ay = v.e1y - 600
				v.bx = v.e2x
				v.by = v.e2y - 600
			end
		elseif lightx >= v.v3x then
			if lighty <= v.y then
				v.c1x = v.v3x
				v.c1y = v.v3y
				v.c2x = v.v1x
				v.c2y = v.v1y
				
				v.ax = v.e1x - 400
				v.ay = v.e1y
				v.bx = v.e2x - 400
				v.by = v.e2y
			elseif lighty >= v.y and
			lighty <= v.v3y then
				v.c1x = v.v3x
				v.c1y = v.v3y
				v.c2x = v.v4x
				v.c2y = v.v4y

				v.ax = v.e2x - 400
				v.ay = v.e2y
				v.bx = v.e2x - 400
				v.by = v.e2y
			elseif lighty >= v.v3y then
				v.c1x = v.v2x
				v.c1y = v.v2y
				v.c2x = v.v4x
				v.c2y = v.v4y
				
				v.ax = v.e1x - 400
				v.ay = v.e1y
				v.bx = v.e2x - 400
				v.by = v.e2y
			end
		end
	end
end

function lightingdraw()
	for i,v in ipairs(enemy) do
		love.graphics.setColor(0,0,0,200)
		love.graphics.polygon("fill",v.c1x,v.c1y, v.e1x,v.e1y, v.e2x,v.e2y, v.c2x,v.c2y)
		love.graphics.polygon("fill",v.e1x,v.e1y, v.ax,v.ay, v.bx,v.by, v.e2x,v.e2y)
		love.graphics.setColor(10,10,10)
		love.graphics.rectangle("fill", v.x, v.y, enemy.width-1, enemy.height-1)
	end
end


function UPDATE_LIGHTING()
	pointtest()
	pointfind()
end

function DRAW_LIGHTING()
	lightingdraw()
end